﻿using AspNetCoreSsrTemplateEngine;
using AspNetCoreSsrTemplateEngine.Renders;
using Unity;

namespace AspNetCoreDefaultHost.Configs
{
    public class UnityContainerComponentResolver : IComponentResolver
    {
        private readonly IUnityContainer _container;

        public UnityContainerComponentResolver(IUnityContainer container)
        {
            _container = container;
        }

        public bool TryResolve<T>(string key, out T render) where T : IRender
        {
            if (_container.IsRegistered<T>(key))
            {
                render = _container.Resolve<T>(key);
                return true;
            }

            render = default;
            return false;
        }

        public bool TryResolve<T>(out T render) where T : IRender
        {
            if (_container.IsRegistered<T>())
            {
                render = _container.Resolve<T>();
                return true;
            }

            render = default;
            return false;
        }
    }
}
