﻿using AspNetCoreDefaultHost.Configs;
using AspNetCoreDefaultHost.Pages;
using AspNetCoreDefaultHost.Utils;
using AspNetCoreVirtualHost;
using Microsoft.AspNetCore.Http;
using System;
using System.Threading.Tasks;
using Unity;

namespace AspNetCoreDefaultHost
{
    public class DefaultVirtualHost : IVirtualHost
    {
        public DefaultVirtualHost(IServiceProvider services)
        {
            HostConfig.Init(services);
        }

        public async Task ProcessRequestAsync(HttpContext context)
        {
            if (context.Request.Path.Value == "/")
            {

                await HostConfig.RootContainer.Resolve<HomePage>().ProcessRequestAsync(context);

                return;
            }

            await HostConfig.RootContainer.Resolve<PageNotFoundPage>().ProcessRequestAsync(context);
        }
    }
}
