using AspNetCoreDefaultHost;
using AspNetCoreVirtualHost;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using Microsoft.Extensions.Logging;
using Unity;

namespace AspNetCoreHello
{
    public class Program
    {
        internal static IUnityContainer VirtualHostContainer { get; private set; }

        public static void Main(string[] args)
        {
            var host = CreateHostBuilder(args).Build();

            var logger = host.Services.GetRequiredService<ILogger<Program>>();
            logger.LogInformation("Starting up...");

            var con = new UnityContainer();
            con.RegisterInstance(typeof(IVirtualHost), new DefaultVirtualHost(host.Services));

            VirtualHostContainer = con;

            host.Run();
        }

        public static IHostBuilder CreateHostBuilder(string[] args)
        {
            return Host.CreateDefaultBuilder(args)
                       .ConfigureWebHostDefaults(webBuilder =>
                       {
                           webBuilder.UseStartup<Startup>();
                       });
        }
    }
}
