using AspNetCoreVirtualHost;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using Unity;

namespace AspNetCoreHello
{
    public class Startup
    {
        // This method gets called by the runtime. Use this method to add services to the container.
        // For more information on how to configure your application, visit https://go.microsoft.com/fwlink/?LinkID=398940
        public void ConfigureServices(IServiceCollection services)
        {
        }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IWebHostEnvironment env)
        {
            if (env.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }

            app.Run(async context =>
            {
                var requestHost = context.Request.Host.Host;

                var virtualHost = Program.VirtualHostContainer.IsRegistered<IVirtualHost>(requestHost)
                    ? Program.VirtualHostContainer.Resolve<IVirtualHost>(requestHost)
                    : Program.VirtualHostContainer.Resolve<IVirtualHost>();

                await virtualHost.ProcessRequestAsync(context);
            });
        }
    }
}
