﻿using AspNetCoreSsrTemplateEngine.Renders;

namespace AspNetCoreSsrTemplateEngine
{
    public interface IComponentResolver
    {
        bool TryResolve<T>(string key, out T render) where T : IRender;
        bool TryResolve<T>(out T render) where T : IRender;

        T Resolve<T>(string key) where T : IRender
        {
            TryResolve<T>(key, out var render);
            return render;
        }

        T Resolve<T>() where T : IRender
        {
            TryResolve<T>(out var render);
            return render;
        }
    }
}
